package com.bjsxt.commons;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ResourceBundle;

public class JdbcUtil {
	private static String driver;
	private static String url;
	private static String username;
	private static String password;
	static{
		ResourceBundle bundle=ResourceBundle.getBundle("jdbc");
		driver=bundle.getString("driver");
		url=bundle.getString("url");
		username=bundle.getString("username");
		password=bundle.getString("password");
		try {
			Class.forName(driver);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public static Connection getConnection(){
		Connection conn=null;
		try{
			conn=DriverManager.getConnection(url, username, password);
		}catch(Exception e){
			e.printStackTrace();
		}
		return conn;
	}
	public static void closeStatement(Statement state){
		try{
			if(state!=null){
				state.close();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	public static void closeConnection(Connection conn){
		try{
			if(conn!=null){
				conn.close();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	public static void closeResoutSet(ResultSet rs){
		try{
			if(rs!=null){
				rs.close();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	//ع
	public static void rollback(Connection conn){
		try{
			if(conn!=null){
				conn.rollback();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	public static void closeResource(Statement state,Connection conn,ResultSet rs){
		closeStatement(state);
		closeConnection(conn);
		closeResoutSet(rs);
	}
}
