package com.bjsxt.dao.impl;


import java.sql.Connection;
import java.sql.ParameterMetaData;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.beanutils.BeanUtils;

import com.bjsxt.commons.JdbcUtil;
import com.bjsxt.dao.BaseDao;

public class BaseDaoImpl implements BaseDao {
	/**
	 * װͨõDML
	 * @author admin
	 *
	 */
	@Override
	public int executeUpdate(String sql, Object[] param) {
		Connection conn=null;
		PreparedStatement ps=null;
		int rows=0;
		try{
			conn=JdbcUtil.getConnection();
			conn.setAutoCommit(false);
			//ִдSQL伴
			ps=conn.prepareStatement(sql);
			//õĸ
			ParameterMetaData pmd=ps.getParameterMetaData();
			//󶨲
			for(int i=0;i<pmd.getParameterCount();i++){
				//setObject÷Բ
				//λòѯ1ʼ󶨵Ĳparam[]
				ps.setObject(1+i, param[i]);
			}
			rows=ps.executeUpdate();
			conn.commit();
		}catch(Exception e){
			e.printStackTrace();
			JdbcUtil.rollback(conn);
		}finally{
			JdbcUtil.closeResource(ps, conn, null);
		}
		return rows;
	}
/**
 * ͨòѯķ
 *  <T> List<T> ͷ
 *  뱣֤ݿбֶ()ͬ
 *  ͨΪȡһֵıǩ
 *  
 *  ע⣺ͨõĲѯҪģͶҪݿеͬ
 */
	@Override
	public <T> List<T> find(String sql, Object[] param, Class<T> clazz) {
		Connection conn=null;
		PreparedStatement ps=null;
		ResultSet rs=null;
		List<T> list=new ArrayList<>();
		try{
			conn=JdbcUtil.getConnection();
			ps=conn.prepareStatement(sql);
			//õĸ
			ParameterMetaData pmd=ps.getParameterMetaData();
			//󶨲
			for(int i=0;i<pmd.getParameterCount();i++){
				//setObject÷Բ
				//λòѯ1ʼ󶨵Ĳparam[]
				ps.setObject(1+i, param[i]);
			}
			//
			rs=ps.executeQuery();
			//ȡϢ
			java.sql.ResultSetMetaData rsmd=rs.getMetaData();
			while(rs.next()){
				//ͨJDKORM
				//ͨģʵ
				//δ֪ʲôT棬ʲônew֮ʲô
				T bean=clazz.newInstance();//Departments d=new Departments();ͨõģnew
				for(int i=0;i<rsmd.getColumnCount();i++){
				//ͨλõõеλô1ʼ+1
					String columnName=rsmd.getCatalogName(i+1);
					//ȡеֵеֵͲȷObject
					Object value=rs.getObject(columnName);//ԸҲԸλ
					//ͨBeanUtilsཫֵ뵽
					//arg1:ĸ arg2:ʲô arg3:ŵֵʲô
					//=ɸvalueŵbean
					BeanUtils.setProperty(bean, columnName, value);
				}
				list.add(bean);
			}
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			JdbcUtil.closeResource(ps, conn, rs);
		}
		return list;
	}

}
