package com.bjsxt.dao.impl;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import com.bjsxt.commons.JdbcUtil;
import com.bjsxt.dao.DepartmentsDao;
import com.bjsxt.pojo.Departments;
import com.bjsxt.pojo.Dept;
/**
 * DepartmentsDaoӿʵ
 * @author admin
 *
 */
public class DepartmentsDaoImpl extends BaseDaoImpl implements DepartmentsDao {

	@Override
	public List<Departments> selectDeptByName(String deptName) {
		Connection conn=null;
		PreparedStatement ps=null;
		ResultSet rs=null;
		List<Departments> list=new ArrayList<Departments>();
		try{
			conn=JdbcUtil.getConnection();
			ps=conn.prepareStatement("select * from departments where department_name = ?");
			ps.setString(1, deptName);
			rs=ps.executeQuery();
			while(rs.next()){
				Departments d=new Departments();
				d.setDepartment_id(rs.getInt("department_id"));
				d.setDepartment_name(rs.getString("department_name"));
				d.setLocation_id(rs.getInt("location_id"));
				list.add(d); 
			}
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			JdbcUtil.closeResource(ps, conn, rs);
		}
		return list;
	}

	@Override
	public void insertDept(Departments dept) {
		Connection conn=null;
		PreparedStatement ps=null;
		try{
			conn=JdbcUtil.getConnection();
			conn.setAutoCommit(false);
			ps=conn.prepareStatement("insert into departments values(default,?,?)");
			ps.setString(1, dept.getDepartment_name());
			ps.setInt(2, dept.getLocation_id());
			ps.execute();
			conn.commit();
		}catch(Exception e){
			e.printStackTrace();
			JdbcUtil.rollback(conn);
		}finally{
			JdbcUtil.closeResource(ps, conn, null);
		}
	}
	//²Ϣ
	@Override
	public int updateDept(Departments dept) {
		String sql="update departments set department_name = ? , location_id = ? where department_id = ?";
		//ðѲDepartmentsdeptóŵObject
		//вλһҪSQLУλһһӦ
		Object[] param=new Object[]{dept.getDepartment_name(),dept.getLocation_id(),dept.getDepartment_id()};
		//ֱӵøBaseDaoImplеķ
		return this.executeUpdate(sql, param);
	}
	//ɾϢ
	@Override
	public int deleteById(int departmentId) {
		String sql="delete from departments where department_id = ?";
		Object[] param=new Object[]{departmentId};
		return this.executeUpdate(sql, param);
	}

	@Override
	public List<Dept> selectDeptByLikeName(String deptName) {
		String sql="select * from departments where department_name like ?";
		//б                 
		Object[] param=new Object[]{"%"+deptName+"%"};
		//arg3:ǰҪĽصĶģ
		return this.find(sql, param,Dept.class);
	}

	

}
